/**
 * A plugin for Lasso.js
 * @param  {lasso/lib/Lasso} lasso An instance of a Lasso that can be configured
 * @param  {Object} The plugin configuration provided by the user
 */
var htmlMin = require("html-minifier");
const fs = require("fs");

module.exports = function(lasso, config) {
  // Register dependency types:
   lasso.dependencies.registerRequireType("html", {
    properties: { path: "string" },

    async init(context) {
      let path = this.path;

      if (!path) {
        throw new Error('"path" is required');
      }

      // console.log(context.options.from, "yyyyyyyyyyyy");
      this.path = path = nodePath.join(context.options.from, path); // Convert the relative path to an absolute path
      // console.log(path, "xxxxxxxxxxxxxxxxxx");
      const stat = await fs.stat(path);
      if (!stat.isDirectory()) {
        throw new Error("Directory expected: " + path);
      }
    },

    // getDependencies: function (lassoContext) {
    //     return [];
    // },

    read: function (lassoContext) {
        return null;
    }
  });


  // Register a custom Node.js/CommonJS module compiler for a custom filename extension
  // var myModule = require('./hello.test');
  lasso.dependencies.registerRequireExtension(
    "html",
    (path, context, callback) => {
      // console.log("html:", path);
      var text = fs.readFileSync(path, "utf8");
      text = htmlMin.minify(text);

      const json = JSON.stringify(text);
      // console.log("aaaaaaaa", json);
      callback(null, `module.exports=${json};`);
    }
  );
};
